﻿
Interface IUPnPDeviceFinder Extends IDispatch
FindByType(bstrTypeURI.p-bstr, dwFlags, *IUPnPDevices)
CreateAsyncFind(bstrTypeURI.p-bstr, dwFlags, *punkDeviceFinderCallback,*plFindData)
StartAsyncFind(lFindData)
CancelAsyncFind(lFindData)
FindByUDN(bstrUDN.p-bstr,*IUPnPDevice)
EndInterface

Interface IUPnPDeviceFinderCallback Extends IUnknown
DeviceAdded(lFindData, *IUPnPDevice)
DeviceRemoved(lFindData, bstrUDN.p-bstr)
SearchComplete(lFindData)
EndInterface

Interface IUPnPServices Extends IDispatch
Count(*plCount)
_NewEnum(*LPUNKNOWN)
Item(bstrServiceId.p-bstr, *IUPnPService)
EndInterface

Interface IUPnPService Extends IDispatch
QueryStateVariable(bstrVariableName.p-bstr, *pValue.variant)
InvokeAction(bstrActionName.p-bstr, vInActionArgs.variant, *pvOutActionArgs.variant, *pvRetVal.variant)
ServiceTypeIdentifier(*pVal)
AddCallback(*pUnkCallback)
Id(*pbstrId)
LastTransportStatus(*plValue)
EndInterface

Interface IUPnPServiceCallback Extends IUnknown
StateVariableChanged(*IUPnPService, pcwszStateVarName.p-unicode, vaValue.variant)
ServiceInstanceDied(*IUPnPService)
EndInterface

Interface IUPnPDevices Extends IDispatch
Count(*plCount)
_NewEnum(*LPUNKNOWN)
Item(bstrUDN.p-bstr, *IUPnPDevice)
EndInterface

Interface IUPnPDevice Extends IDispatch
IsRootDevice(*pvarb)
RootDevice(*IUPnPDevice)
ParentDevice(*IUPnPDevice)
HasChildren(*pvarb)
Children(*IUPnPDevices)
UniqueDeviceName(*pbstr)
FriendlyName(*pbstr)
Type(*pbstr)
PresentationURL(*pbstr)
ManufacturerName(*pbstr)
ManufacturerURL(*pbstr)
ModelName(*pbstr)
ModelNumber(*pbstr)
Description(*pbstr)
ModelURL(*pbstr)
UPC(*pbstr)
SerialNumber(*pbstr)
IconURL(bstrEncodingFormat.p-bstr,lSizeX,lSizeY,lBitDepth,*pbstrIconURL)
Services(*IUPnPServices)
EndInterface

Interface IUPnPDeviceDocumentAccess Extends IUnknown
GetDocumentURL(*pbstrDocument)
EndInterface

Interface IUPnPDescriptionDocument Extends IDispatch
ReadyState(*plReadyState)
Load(bstrUrl.p-bstr)
LoadAsync(bstrUrl.p-bstr,  *punkCallback)
LoadResult(*phrError)
Abort()
RootDevice(*ppudRootDevice.IUPnPDevice)
DeviceByUDN(bstrUDN.p-bstr,  *ppudDevice.IUPnPDevice)
EndInterface

Interface IUPnPDescriptionDocumentCallback Extends IUnknown
LoadComplete(hrLoadResult)
EndInterface

Interface IUPnPNAT Extends IDispatch
get_StaticPortMappingCollection(*IStaticPortMappingCollection)
get_DynamicPortMappingCollection(*IDynamicPortMappingCollection)
get_NATEventManager(*INATEventManager)
EndInterface

Interface IStaticPortMappingCollection Extends IDispatch
Get__NewEnum(*IUnknown)
Get_Item(lExternalPort, bstrProtocol.p-bstr,*IStaticPortMapping)
get_Count(*pVal)
Remove(lExternalPort,bstrProtocol.p-bstr)
Add(lExternalPort,bstrProtocol.p-bstr,lInternalPort,bstrInternalClient.p-bstr,bEnabled.l,bstrDescription.p-bstr,*IStaticPortMapping)
EndInterface

Interface IStaticPortMapping Extends IDispatch
get_ExternalIPAddress(*pVal)
get_ExternalPort(*pVal)
get_InternalPort(*pVal)
get_Protocol(*pVal)
get_InternalClient(*pVal)
get_Enabled(*pVal)
get_Description(*pVal)
EditInternalClient(bstrInternalClient.p-bstr)
Enable(vb)
EditDescription(bstrDescription.p-bstr)
EditInternalPort(lInternalPort)
EndInterface

DataSection
iid_iupnpdevicefinder: ;ADDA3D55-6F72-4319-BFF9-18600A539B10
Data.l $ADDA3D55
Data.w $6F72, $4319
Data.b $BF, $F9, $18, $60, $0A, $53, $9B, $10
EndDataSection


DataSection
CLSID_iupnpdevicefinder: ;E2085F28-FEB7-404A-B8E7-E659BDEAAA02
Data.l $E2085F28
Data.w $FEB7, $404A
Data.b $B8, $E7, $E6, $59, $BD, $EA, $AA, $02
EndDataSection

DataSection
IID_IUPnPDevice: ;3D44D0D1-98C9-4889-ACD1-F9D674BF2221
Data.l $3D44D0D1
Data.w $98C9, $4889
Data.b $AC, $D1, $F9, $D6, $74, $BF, $22, $21
EndDataSection

DataSection 
iid_ienumvariant: ;00020404-0000-0000-C000-000000000046
Data.l $00020404
Data.w $0000, $0000
Data.b $C0, $00, $00, $00, $00, $00, $00, $46
EndDataSection

DataSection 
IID_IUPnPNAT: ;B171C812-CC76-485A-94D8-B6B3A2794E99
Data.l $B171C812
Data.w $CC76, $485A
Data.b $94, $D8, $B6, $B3, $A2, $79, $4E, $99
EndDataSection

DataSection
CLSID_UPnPNAT: ;AE1E00AA-3FD5-403C-8A27-2BBDC30CD0E1
Data.l $AE1E00AA
Data.w $3FD5, $403C
Data.b $8A, $27, $2B, $BD, $C3, $0C, $D0, $E1
EndDataSection

DataSection
IID_IStaticPortMappingCollection: ;CD1F3E77-66D6-4664-82C7-36DBB641D0F1
Data.l $CD1F3E77
Data.w $66D6, $4664
Data.b $82, $C7, $36, $DB, $B6, $41, $D0, $F1
EndDataSection

DataSection 
IID_IStaticPortMapping: ;6F10711F-729B-41E5-93B8-F21D0F818DF1
Data.l $6F10711F
Data.w $729B, $41E5
Data.b $93, $B8, $F2, $1D, $0F, $81, $8D, $F1
EndDataSection


; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 65
; FirstLine = 35
; EnableUnicode
; EnableXP